KNIFE-XARGS(1)

NAME
knife-xargs - The man page for the knife xargs subcommand.

The knife xargs subcommand is used to take patterns from standard input, download as JSON, run a command against the downloaded JSON, and then upload any changes.

Syntax

This subcommand has the following syntax:

$ knife xargs [PATTERN...] (options)

Options

This subcommand has the following options:

-0  Use to show a NULL character (\0) instead of white space as the separator. Default: false.

--chef-repo-path PATH
    The path to the chef-repo. This setting will override the default path to the chef-repo. Default: same as specified by chef_repo_path in config.rb.

--concurrency
    The number of allowed concurrent connections. Default: 10.

--[no-]diff
    Use to show a diff when a file changes. Default: --diff.

--dry-run
    Use to prevent changes from being uploaded to the Chef server. Default: false.

--[no-]force
    Use to force the upload of files even if they haven't been changed. Default: --no-force.

-I REPLACE_STRING, --replace REPLACE_STRING
    Use to define a string that will be used to replace all occurrences of a file name. Default: nil.

-J REPLACE_STRING, --replace-first REPLACE_STRING
    Use to define a string that will be used to replace the first occurrence of a file name. Default: nil.

--local
    Use to build or execute a command line against a local file. Set to false to build or execute against a remote file. Default: false.

-n MAX_ARGS, --max-args MAX_ARGS
    The maximum number of arguments per command line. Default: nil.

-p [PATTERN...], --pattern [PATTERN...]
    One (or more) patterns for a command line. If this option is not specified, a list of patterns may be expected on standard input. Default: nil.

--repo-mode MODE
    The layout of the local chef-repo. Possible values: static, everything, or hosted_everything. Use static for just roles, environments, cookbooks, and data bags. By default, everything and hosted_everything are dynamically selected depending on the server type. Default value: default.

-s LENGTH, --max-chars LENGTH
    The maximum size (in characters) for a command line. Default: nil.

-t  Use to run the print command on the command line. Default: nil.

-c CONFIG_FILE, --config CONFIG_FILE
    The configuration file to use.

--chef-zero-port PORT
    The port on which chef-zero will listen.

-d, --disable-editing
    Use to prevent the $EDITOR from being opened and to accept data as-is.

--defaults
    Use to have knife use the default value instead of asking a user to provide one.

-e EDITOR, --editor EDITOR
    The $EDITOR that is used for all interactive commands.

-E ENVIRONMENT, --environment ENVIRONMENT
    The name of the environment. When this option is added to a command, the command will run only against the named environment.

-F FORMAT, --format FORMAT
    The output format: summary (default), text, json, yaml, and pp.

-h, --help
    Shows help for the command.

-k KEY, --key KEY
    The private key that knife will use to sign requests made by the API client to the Chef server.

--[no-]color
    Use to view colored output.

--print-after
    Use to show data after a destructive operation.

--server-url URL
    The URL for the Chef server.

-u USER, --user USER
    The user name used by knife to sign requests made by the API client to the Chef server. Authentication will fail if the user name does not match the private key.

-v, --version
    The version of the chef-client.

-V, --verbose
    Set for more verbose outputs. Use -VV for maximum verbosity.

-y, --yes
    Use to respond to all confirmation prompts with "Yes". knife will not ask for confirmation.

-z, --local-mode
    Use to run the chef-client in local mode. This allows all commands that work against the Chef server to also work against the local chef-repo.

    Examples

    The following examples show various ways of listing all nodes on the server, and then using Perl to replace grantmc with gmc:

    $ knife list 'nodes/*' | knife xargs "perl -i -pe 's/grantmc/gmc'"

    or without quotes and the backslash escaped:

    $ knife list /nodes/\* | knife xargs "perl -i -pe 's/grantmc/gmc'"

    or by using the --pattern option:

    $ knife xargs --pattern '/nodes.*' "perl -i -pe 's/grantmc/gmc'"

AUTHOR
Chef